﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Windows.ApplicationModel;

namespace App1
{
    public class MainPageViewModel : BindableBase
    {
        private IList<Person> _people;
        private ICommand _loadPersonCommand;

        /// <summary>
        /// People = list
        /// </summary>
        public IList<Person> People
        {
            get { return _people; }
            set { SetProperty(ref _people ,value); }
        }

        public MainPageViewModel()
        {
            People = new ObservableCollection<Person>();
            if (DesignMode.DesignModeEnabled)
            {
                var addPerson = new Person(1, "test1", "http://icon.daumcdn.net/w/icon/1512/30/111851315.jpg", "test");
                People.Add(addPerson);
            }
        }

        public ICommand LoadPersonCommand
        {
            get
            {
                return _loadPersonCommand = _loadPersonCommand ?? new DelegateCommand(obj =>
                {
                    var addPerson = new Person(1, "test1", "http://icon.daumcdn.net/w/icon/1512/30/111851315.jpg", "test");
                    People.Add(addPerson);
                });
            }
        }
    }
}
